/**
 * ContentToolkit.java
 * Lc@Fa
 * 20052005/11/3010:58:05
 */
package org.hichart.h3code.content;

//import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.font.FontRenderContext;
import java.awt.font.LineBreakMeasurer;
import java.awt.font.TextLayout;
import java.text.AttributedString;

import org.hichart.h3code.Cell;
import org.hichart.h3code.Content;

/**
 * @author Tomokazu ARITA
 *
 */
public class ContentToolkit {
	
	private Cell cell;
	private Content content = null;
	
    public ContentToolkit(Cell cell){
    	this.cell = cell;
    	this.content = cell.getContent();
    }
    
    
    /**
     * Rec`悷ƂgpB
     * @param g2: `悷Graphics2D
     */
    public void draw(Graphics2D g2){
    	if(g2==null || content==null){ return; }
    	if(content instanceof TextLine){
    		drawString(g2);
    	}
    }
    
    private void drawString(Graphics2D g2){
    	
    	if(content instanceof TextLine){
    		TextLine tl = (TextLine)content;
    		
    		//STEP1 FontRenderContext擾
    		FontRenderContext context = g2.getFontRenderContext();
    		
    		//STEP2 Font쐬
    		//Font font = new Font("Serif", Font.PLAIN, 12);
    		
    		//STEP3 tɕύXiIɑtT|[g邽߁j
    		AttributedString a_string = new AttributedString(tl.getContent());
    		LineBreakMeasurer measurer = new LineBreakMeasurer(a_string.getIterator(), context);
    		
    		//sݒ
    		float line_width = (float)(cell.getWall(Cell.EAST) - cell.getWall(Cell.WEST) - tl.getOffset());
    		
    		//\
    		float textX = tl.getOffset()+cell.getWall(Cell.WEST); //ItZbg𓾂
    		float textY = tl.getOffset() + cell.getWall(Cell.NORTH);
    		while (measurer.getPosition() < tl.getContent().length()) {
    	         TextLayout layout = measurer.nextLayout(line_width);
    	         textY += (layout.getAscent());
    	         layout.draw(g2, textX, textY);
    	         textY += layout.getDescent() + layout.getLeading();
    	         if(textY >= cell.getWall(Cell.SOUTH) - tl.getOffset()){ break; }
    	     }
    	}
    }
}
