/*
 * H3CContentParser.java
 * Tomokazu ARITA
 * arita@r.dendai.ac.jp
 * Created on 2003/08/14, 17:09
 * up 2005/12/04
 */

/*  */
/* ParserñNX̃CX^X́C
 Ōɉ͂t@C̃f[^ێD
 ̂߁C[𑽂D
 gpꍇ́CK؂ɐE邩
 Iinit()\bhĂяoC|C^Zbg邱
 */

package org.hichart.h3code.tool;

//import java.util.ArrayList;
import java.util.StringTokenizer;
import java.io.BufferedReader;
import java.util.regex.Pattern;

import org.hichart.h3code.AbstractContentTypeTable;
import org.hichart.h3code.Cell;
import org.hichart.h3code.Table;
import org.hichart.h3code.content.TextLine;

/**
 * H3-Code Content Part Parser
 * @author Tomokazu ARITA (arita@obirin.ac.jp)
 * @version 0.0.1
 *
 */
public class H3CContentParser {
    
    
/*
    public static final int CONTENT_ID = 1;
    public static final int KIND_OF_CONTENT = 2;
    // 1Recs̃Rec̃g[Nԍ
    public static final int CONTENT_PART = 3; //3ڂ̃g[NRec
*/
	
    /* Table */
    //Table table = null;
    
    /* p^[ */
    
    /* (1)󔒂ŕ */
    Pattern pattern_space = Pattern.compile("[ \\t\\n\\x0B\\f\\r]+?");
    
    
    private int id; 
    private int type = org.hichart.h3code.AbstractContentTypeTable.NONE;
    private String data = null;
    
    /** Creates a new instance of H3CContentParser */
    public H3CContentParser(){}
    
    //
    public void init(){
    	//table = null;
        initFields();
    }
    
    private void initFields(){
    	id = -1; 
        type = org.hichart.h3code.AbstractContentTypeTable.NONE;
        data = null;
    }
    
    //
    public void analyze(BufferedReader br, org.hichart.h3code.Table table){
        init();
        
        //this.table = table; //e[uZbg
        //int size = table.getCellSet().size();
        //table.clearContentSet();
        //table.setContentSet(new ArrayList(size+10));
        //table.addContent(0, null);
        
        try{
            analyzeHeader(br.readLine()); //sڂ̃wbh
            
            String line;
            
            while((line = br.readLine()) != null){

            	//s
            	System.out.println("This line length = "+line.length());//debug
            	if(line.length() == 0){continue;} //s̍s
                
                //Rg
                StringBuffer sb = new StringBuffer(line);
                if(sb.charAt(0)=='%'){continue;}
                    
                //C
                analyzeContentLine(line, table);
            }
            
        }catch(Exception e){
        	System.out.println(e);
        }
        
        System.out.println("Finished for HCC.");
    }
    
    /* wbh̉ */
    public boolean analyzeHeader(String line){
        StringTokenizer st = new StringTokenizer(line, " ");
        
        for(int state=1; st.hasMoreTokens(); state++){
            switch(state){
                case 1: //H3-Code Version
                    try{ setH3CVersion( Integer.parseInt(st.nextToken())); }
                    catch(Exception e){ return false; }
                    break;
                case 2: //Number of Contents
                    try{ setContentSize( Integer.parseInt(st.nextToken())); }
                    catch(Exception e){ return false; }
                    break;
                default:
                    return false;
            }
        }
         return true;
    }
    
    /* Recs̉ */
    public boolean analyzeContentLine(String line, Table table){
    	
    	String s[] = pattern_space.split(line);
        
    	setContentID( Integer.parseInt(s[0]) );
    	setKindOfContent( Integer.parseInt(s[1]) );
    	
    	String contentS = "";
    	for(int i=2; i<s.length; i++){
    		contentS += s[i];
    		if(i!=s.length-1){
    			contentS += " ";
    		}
    	}
    	setContent( contentS );
    	
    	constructContent(table);
    	
        return true;
    }

    
    
    /* private methods */
    
    /* o[WǗ */
    private void setH3CVersion(int version){
            System.out.println("H3-Code Version:"+ version);
    }
    
    /* Rec */
    private void setContentSize(int size){
        System.out.println("This file Includes " + size + " Contents.");
    }
    
    /* RecID̓o^ */
    private void setContentID(int id){
        this.id = id;
        System.out.println("Content ID = "+ id);
    }
    
    /* Rec̎ނ̓o^ */
    private void setKindOfContent(int kind){
        this.type = kind;
        System.out.println("Content Type = "+ kind);
    }
    
    /* Rec̃f[^ */
    private void setContent(String data){
        this.data = data;
        System.out.println("Data"+data);
    }
    
    /* Rec̓o^ */
    private void constructContent(Table table){
        if(type != AbstractContentTypeTable.NONE){
        	System.out.println("CONSTRUCT!");
        	org.hichart.h3code.Content content;
            switch(type){
                case org.hichart.h3code.AbstractContentTypeTable.TEXT:
                    content = new org.hichart.h3code.content.gui.CText();
                    break;
                case org.hichart.h3code.AbstractContentTypeTable.KIND_TEXT_LINE:
                	content = new TextLine();
                	break;
                default:
                    return; //ӖȂꍇ̓\bh𔲂
            }
            content.setContentID(id);
            content.setKindOfContent(type);
            content.setContent(data);
            
            //Rec̐ݒ
            Cell cell = (Cell)table.getCellSet().get(id);
            cell.setContent(content);
            initFields();
        }
    }
}
