/*
 * H3CFileLoader.java
 * Tomokazu ARITA
 * Created on 2003/08/16, 6:49
 */

package org.hichart.h3code.tool;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import java.io.File;


/**
 * Class for select H3-Code files
 * @author Tomokazu ARITA (arita@obirin.ac.jp)
 * @version 0.1.0  2003/08/16
 */
public class H3CFileLoader {
    
    private JFileChooser chooser;
    private JFrame frame;
    
    private File htcFile;
    private File htcFileDir;
//    private String htcFileName; //t@C̖O
//    private String htcFilePath; //t@C̊SpX
//    private String htcFileDirectory; //t@C̃fBNg
    
    /** Creates a new instance of H3CFileLoader */
    public H3CFileLoader(JFrame frame){
        this.frame = frame;
    }
    
    /**
     * Shows a File Chooser
     */
    public void showHTCFileChooser(){
         chooser = new JFileChooser();
         chooser.addChoosableFileFilter(new H3CFileFilter());
         
         int value = chooser.showOpenDialog(frame);
         if(value == JFileChooser.APPROVE_OPTION){//t@CIꂽ
             htcFile = chooser.getSelectedFile();
             htcFileDir = chooser.getCurrentDirectory();
         }
    }
    
    
    /**
     * Shows a File Chooser with a directory
     * @param dir
     */
    public void showHTCFileChooser(File dir){
         chooser = new JFileChooser(dir);
         chooser.addChoosableFileFilter(new H3CFileFilter());
         
         int value = chooser.showOpenDialog(frame);
         if(value == JFileChooser.APPROVE_OPTION){//t@CIꂽ
             htcFile = chooser.getSelectedFile();
             htcFileDir = chooser.getCurrentDirectory();
         }
    }
    
    /**
     * Get a selected file. 
     * @return a File class
     */
    public File getFile(){
        return htcFile;
    }
    
    /**
     * Get a selected directory.
     * @return a File class for this current directory of files. 
     */
    public File getDir(){
        return htcFileDir;
    }
}
