/*
 * SimpleTableDrawer.java
 * Tomokazu ARITA
 * arita@r.dendai.ac.jp
 * Created on 2003/09/06, 0:57
 */

package org.hichart.h3code.tool;

import java.awt.Graphics2D;
//import java.awt.Dimension;
import java.awt.Color;
import java.awt.Paint;
import java.util.ArrayList;
import java.util.Iterator;

import org.hichart.h3code.AbstractCell;
import org.hichart.h3code.Table;

public class SimpleTableDrawer {
    
    private Paint bgColor = (Paint)Color.white; //wi̐F
    private Paint borderColor = (Paint)Color.black; //Z̐̐F
    
    /* RXgN^ */
    public SimpleTableDrawer(){}
    
    
    /* e[u̕` */
    public void draw(Graphics2D g2, Table table){
        if(table == null || g2 ==null){ return; }//e[uȂȂΏI
        
        /* wiFŔwi` */
        if(bgColor != null){
            g2.setPaint(bgColor); //wi̐FZbg
            g2.fillRect(0, 0, table.getWidth(), table.getHeight()); //wi`
        }
        
        /* eZ̕` */
        ArrayList cells = table.getCellSet();
        Iterator it = cells.iterator();
        while(it.hasNext()){
            Object obj = it.next();
            if(obj instanceof org.hichart.h3code.Cell){
            	org.hichart.h3code.Cell cell = (org.hichart.h3code.Cell)obj;
                
                /* {[_[̐FZbg */
                g2.setPaint(borderColor);
                
                /* Z̕` */
                g2.drawRect(cell.getWall(AbstractCell.WEST), cell.getWall(AbstractCell.NORTH), cell.getWall(AbstractCell.EAST)-cell.getWall(AbstractCell.WEST), cell.getWall(AbstractCell.SOUTH)-cell.getWall(AbstractCell.NORTH));
            }
        }
    }
    
}
